#include <QTextStream>
#include <QCryptographicHash>
#include <QByteArray>
#include <QStringList>
#include <QCoreApplication>

QTextStream cout(stdout);
QTextStream cerr(stderr);

QString usage() {
   return QString("usage:\n\t%1\n\t%2\n\t%3\n\t%4")
      .arg("encrypt string alg")
      .arg("where alg can be one of three algorithms:")
      .arg("Md4, Md5, or Sha1. If this switch is absent")
      .arg("the default will be Sha1.");
}

int main(int argc, char** argv) {
  QCoreApplication qca(argc, argv);
  QStringList al(qca.arguments());
  if(al.count() < 2) {
      cerr << usage() << endl;
      return 1;
   }
   al.takeFirst(); //Get rid of the app name.
   QByteArray qba;
   qba.append(al.takeFirst()); // String to be hashed
   
   QString algarg = al.takeFirst().toLower();
   QCryptographicHash::Algorithm alg;
   if(algarg == "md4")
      alg = QCryptographicHash::Md4;
   else if(algarg == "md5")
      alg = QCryptographicHash::Md5;
   else
      alg = QCryptographicHash::Sha1;
   cout << QCryptographicHash::hash(qba, alg) << endl;
}

